# funktionen.py
from math import *

def wenn(bedingung, wenn_erfuellt, wenn_nicht):
    '''Alle Parameter muessen Strings sein.'''
    if (eval(str(bedingung))):
        return eval(str(wenn_erfuellt))
    else:
        return eval(str(wenn_nicht))

def Wenn(bedingung, wenn_erfuellt, wenn_nicht):
    '''andere Schreibweise ermoeglichen'''
    return wenn(bedingung, wenn_erfuellt, wenn_nicht)

def wurzel(x): return sqrt(x)
def quadrat(x): return x*x
def potenz(x,n): return pow(x,n)

### ----- WerteTabelle -------------------------------------
### Variante mit Einsatz von Vererbung
class WerteTabelle(object):
    '''Stellt den Zugriff auf Tabellenwerte bereit, in dieser
    Variante fuer Paare von Wert einer Groesse (als Stelle) und
    zugeordnetem Tabellenwert;
    die Zwischenwerte werden standardmaessig interpoliert'''
    def __init__(self, stellen=[], werte=[]):
        assert len(stellen)==len(werte), 'Listen muessen gleich lang sein!'
        self.stellen=[] # zunaechst leer, Fuellen ueber Methode
        self.werte=[] # zunaechst leer, Fuellen ueber Methode
        self.__interpolieren=True # umschalten moeglich
        for i in range(len(stellen)):
            self.NeuesWertePaar((stellen[i],werte[i]))

    def SetzeInterpolieren(self, interpolieren=True):
        '''umschalten interpolieren oder nicht'''
        self.__interpolieren=interpolieren

    def GibWert(self, stelle):
        '''Die eigentliche Zugriffsfunktion interpoliertt standardmaessig
        zwischen den Stellen der Tabelle fuer die uebergebene Stelle;
        die Stellen der Tabelle muessen zwingend geordnet sein
        von klein nach gross'''
        if len(self.stellen)==0: return 0 # leere Tabelle abfangen
        if stelle<= self.stellen[0]: # Stelle vor Beginn
            return self.werte[0]
        letzte=len(self.stellen)-1
        if stelle>= self.stellen[letzte]: # Stelle hinter Ende
            return self.werte[letzte]
        for i in range(letzte):
            if (stelle>=self.stellen[i]) and (stelle<=self.stellen[i+1]):
                if self.__interpolieren: #interpoliert
                    x1,x2=self.stellen[i],self.stellen[i+1]
                    y1,y2=self.werte[i],self.werte[i+1]
                    return ((stelle-x1)*y2+(x2-stelle)*y1)/(x2-x1)
                else: # gibt allein den unteren Werte zurueck
                    return self.werte[i]

    def GibTabelle(self):        
        return (self.stellen, self.werte)
    
    def GibTabellenPaare(self):
        l=[]
        for i in range(len(self.stellen)):
            l.append((self.stellen[i], self.werte[i]))
        return l
    
    def EnthaeltStelle(self, stelle):
        return stelle in self.stellen

    def NeuesWertePaar(self, paar):
        stelle,wert=paar
        if len(self.stellen)==0:
            self.stellen,self.werte=[stelle],[wert]
        elif stelle in self.stellen: # ersetzen
            self.werte[self.stellen.index(stelle)]=wert
        elif stelle<self.stellen[0]: # davor
            self.stellen=[stelle]+self.stellen
            self.werte=[wert]+self.werte
        elif stelle>self.stellen[len(self.stellen)-1]: # anhaengen
            self.stellen.append(stelle)
            self.werte.append(wert)
        else: # einfuegen
            for i in range(len(self.stellen)-1):
                if stelle>=self.stellen[i]:
                    if stelle<self.stellen[i+1]:
                        self.stellen.insert(i+1,stelle)
                        self.werte.insert(i+1,wert)
                        break

### ----- Tabelle ------------------------------------------
### speziell fuer die Zeiten
class Tabelle(WerteTabelle):
    '''Stellt den Zugriff auf Tabellenwerte bereit.
    Die Liste der Zeitpunkte fuer die Aenderungen muss
    den Startwert 0 enthalten und aufsteigend geordnet sein;
    die Zwischenwerte werden interpoliert'''
    def __init__(self, zeiten=[], werte=[]):
        WerteTabelle.__init__(self, zeiten, werte)

    def GibWert(self, t):
        '''Die eigentliche Zugriffsfunktion interpoliert zwischen
        den Zeiten in der Tabelle fuer die uebergebene Zeit;
        die Zeiten in der Tabelle muessen zwingend geordnet sein
        von klein nach gross und t muss mindestens 0 sein;'''
        if len(self.stellen)==0: return 0 # leere Tabelle abfangen
        if t<=0: t=0 # Zeit vor Beginn geht nicht
        return super(Tabelle, self).GibWert(t)
    
    def EnthaeltZeit(self, zeit):
        return self.EnthaeltStelle(zeit)

    def NeuesWertePaar(self, paar):
        if paar[0]<0: return
        super(Tabelle, self).NeuesWertePaar(paar)

### ---------------------------------------------------------------
## Tests:
##tabelle=Tabelle([0, 2.0, 3.0, 5.0],[2.0, 4.0, 9.0, 25.0])    
##print(tabelle.GibTabelle())
##print(-10.0,tabelle.GibWert(-10.0)) # sinnlos
##print(0,tabelle.GibWert(0))
##print(0.3,tabelle.GibWert(0.3))
##print(2.1,tabelle.GibWert(2.1))
##print(2.5,tabelle.GibWert(2.5))
##print(3.0,tabelle.GibWert(3.0))
##print(4.0,tabelle.GibWert(4.0))
##print(5.0,tabelle.GibWert(5.0))
##print(5.5,tabelle.GibWert(5.5))
##tabelle.NeuesWertePaar((1.5,2.25))
##tabelle.NeuesWertePaar((6.0,36.0))
##print(tabelle.GibTabelle())
##print(1.9,tabelle.GibWert(1.9))
##print(5.5,tabelle.GibWert(5.5))
##print(9,tabelle.GibWert(9))
##print(tabelle.GibTabellenPaare())
##
##print('\n')
##tabelle=WerteTabelle([-3, 0.0, 2.0, 5.0],[1.0, 4.0, 9.0, 25.0])
##print(tabelle.GibTabelle())
##print(-10,tabelle.GibWert(-10))
##print(-1,tabelle.GibWert(-1))
##print(0.0,tabelle.GibWert(0.0))
##print(1.0,tabelle.GibWert(1.0))
##print(3.5,tabelle.GibWert(3.5))
##print(5.5,tabelle.GibWert(5.5))
##print('Interpolieren aus:')
##tabelle.SetzeInterpolieren(False)
##print(-10,tabelle.GibWert(-10))
##print(-1,tabelle.GibWert(-1))
##print(0.0,tabelle.GibWert(0.0))
##print(1.0,tabelle.GibWert(1.0))
##print(3.5,tabelle.GibWert(3.5))
##print(5.5,tabelle.GibWert(5.5))
##print('Interpolieren wieder an:')
##tabelle.SetzeInterpolieren(True)
##print(-10,tabelle.GibWert(-10))
##print(-1,tabelle.GibWert(-1))
##print(0.0,tabelle.GibWert(0.0))
##print(1.0,tabelle.GibWert(1.0))
##print(3.5,tabelle.GibWert(3.5))
##print(5.5,tabelle.GibWert(5.5))
##print('\n')
##tabelle.NeuesWertePaar((1.5,8.0))
##tabelle.NeuesWertePaar((6.0,36.0))
##print(tabelle.GibTabelle())
##print(1.9,tabelle.GibWert(1.9))
##print(5.5,tabelle.GibWert(5.5))
##print(5.9,tabelle.GibWert(5.9))
##print(6,tabelle.GibWert(6))
##print(9,tabelle.GibWert(9))
##print()
##tabelle.NeuesWertePaar((5.999,25.0))
##print(tabelle.GibTabelle())
##print(5.9,tabelle.GibWert(5.9))
##print(5.99975,tabelle.GibWert(5.99975))
##print(6,tabelle.GibWert(6))
##print(9,tabelle.GibWert(9))
##print(tabelle.GibTabellenPaare())
##
### Fehler testen
##print('\n')
##print('Zeiten sind >0.')
##tabelle=Tabelle([-1.0],[2.0])
##print(tabelle.GibTabelle())
##tabelle=WerteTabelle([-3, 0.0, 2.0, 5.0],[1.0, 4.0, 9.0, 25.0])
##print(tabelle.GibTabelle())
##print('Ungeordnete Tabellen werden geordnet.')
##tabelle=WerteTabelle([5.0, 2.0, -3, 0.0],[25.0, 9.0, 1.0, 4.0])
##print(tabelle.GibTabelle())
