# -*- coding: utf-8 -*-
## modellfenster.py
## © Claus Albowski

## Importe:
import os
import platform
versionsNummer=platform.python_version()[0]
if versionsNummer=='3': from tkinter import *
else: from Tkinter import *
#### vordefinierte Dialoge
if versionsNummer=='2':
    import tkFileDialog as fileDialog
    import tkMessageBox  as tkmessagebox
else:
    import tkinter.filedialog as fileDialog
    import tkinter.messagebox as tkmessagebox
from random import randint

from simulationsprojekt.simulation import *
from simulationsprojekt.grafikFenster import *
from simulationsprojekt.modellfensterElemente import *
from simulationsprojekt.dialoge import *
from simulationsprojekt.funktionen import * #  wenn und Tabelle
from simulationsprojekt.term import * # fuer die Bearbeitung von Termen

class ModellFensterApplication(Frame):
    
    def __init__(self, master=None,
                 zeichenflaecheBreite=800,
                 zeichenflaecheHoehe=800,
                 scroll=True,
                 schwarz=False):
        Frame.__init__(self, master)
        self.breite = zeichenflaecheBreite
        self.hoehe = zeichenflaecheHoehe
        if schwarz:
            self.__fg,self.__bg='white','black'
            CanvasElement.Setze_FG_BG('white','black')
            Dialog.Setze_FG_BG('white','gray')
        else:
            self.__fg,self.__bg='black','white'
            CanvasElement.Setze_FG_BG('black','white')
            Dialog.Setze_FG_BG('black','white')
        self.__scroll=scroll

        top = self.winfo_toplevel()
        ## Menübereich
        self.menuBar = Menu(top)
        top['menu'] = self.menuBar
        #### Datei-Menu
        self.dateiSubMenu = Menu(self.menuBar)
        self.menuBar.add_cascade(label='Datei', font='Sans 10 bold', menu=self.dateiSubMenu)
        self.dateiSubMenu.add_command(label='Daten einlesen', font='Sans 10 bold', command=self.onLesen)
        self.dateiSubMenu.add_command(label='Daten speichern', font='Sans 10 bold', command=self.onSpeichern)
        self.dateiSubMenu.add_command(label='Modellverzeichnis zurücksetzen', font='Sans 10 bold', command=self.onVerzeichnis)
        self.dateiSubMenu.add_separator()
        self.dateiSubMenu.add_command(label='Teilmodell importieren', font='Sans 10 bold', command=self.onImport)
        self.dateiSubMenu.add_separator()
        self.dateiSubMenu.add_command(label='Beenden', font='Sans 10 bold', command=self.onBeenden)
        #### Modellentwicklungs-Menu
        self.neuSubMenu = Menu(self.menuBar)
        self.menuBar.add_cascade(label='Modellentwicklung', font='Sans 10 bold', menu=self.neuSubMenu)
        self.neuSubMenu.add_command(label='Neues Modell', font='Sans 10 bold', command=self.onNeuesModell)
        self.neuSubMenu.add_command(label='Bestandsfaktor', font='Sans 10 bold', command=self.onBestand)
        self.neuSubMenu.add_command(label='Fluss', font='Sans 10 bold', command=self.onFluss)
        self.neuSubMenu.add_command(label='Parameter', font='Sans 10 bold', command=self.onParameter)
        self.neuSubMenu.add_command(label=u'Zwischengröße', font='Sans 10 bold', command=self.onZwischengroesse)
        self.neuSubMenu.add_command(label='Wirkung', font='Sans 10 bold', command=self.onWirkung)
        self.neuSubMenu.add_command(label='Wirkung mit Maus', font='Sans 10 bold', command=self.onWirkungMaus)
        #### Bearbeiten-Menu
        self.bearbeitenSubMenu = Menu(self.menuBar)
        self.menuBar.add_cascade(label='Bearbeiten', font='Sans 10 bold', menu=self.bearbeitenSubMenu)
        self.bearbeitenSubMenu.add_command(label='Bestandsfaktor', font='Sans 10 bold', command=self.onBestandBearbeiten)
        self.bearbeitenSubMenu.add_command(label='Fluss', font='Sans 10 bold', command=self.onFlussBearbeiten)
        self.bearbeitenSubMenu.add_command(label='Parameter', font='Sans 10 bold', command=self.onParameterBearbeiten)
        self.bearbeitenSubMenu.add_command(label=u'Zwischengröße', font='Sans 10 bold', command=self.onZwischengroesseBearbeiten)
        self.bearbeitenSubMenu.add_command(label='Term', font='Sans 10 bold', command=self.onTermBearbeiten)
        self.bearbeitenSubMenu.add_command(label='Bogen bei Wirkung bearbeiten', font='Sans 10 bold', command=self.onWirkungBearbeiten)
        self.bearbeitenSubMenu.add_command(label='Pfeile aktualisieren', font='Sans 10 bold', command=self.onPfeileAktualisieren)
        #### Tabellen-Menu
        self.tabellenSubMenu = Menu(self.menuBar)
        self.menuBar.add_cascade(label=u'Tabellen', font='Sans 10 bold', menu=self.tabellenSubMenu)
        self.tabellenSubMenu.add_command(label='Tabelle verwenden', font='Sans 10 bold', command=self.onTabelleNeu)
        self.tabellenSubMenu.add_command(label='Tabellenwerte eingeben', font='Sans 10 bold', command=self.onTabelleneingabe)
        self.tabellenSubMenu.add_command(label='Tabellenwerte interpolieren', font='Sans 10 bold', command=self.onInterpolierenAn)
        self.tabellenSubMenu.add_command(label='Tabellenwerte nicht interpolieren', font='Sans 10 bold', command=self.onInterpolierenAus)
        self.tabellenSubMenu.add_command(label='Tabelle loeschen', font='Sans 10 bold', command=self.onLoescheTabelle)
        self.tabellenSubMenu.add_command(label='Tabellenwerte anzeigen', font='Sans 10 bold', command=self.onTabelleAnzeigen)
        #### Loeschen-Menu
        self.loeschenSubMenu = Menu(self.menuBar)
        self.menuBar.add_cascade(label=u'Löschen', font='Sans 10 bold', menu=self.loeschenSubMenu)
        self.loeschenSubMenu.add_command(label='Bestandsfaktor', font='Sans 10 bold', command=self.onLoescheBestand)
        self.loeschenSubMenu.add_command(label='Fluss', font='Sans 10 bold', command=self.onLoescheFluss)
        self.loeschenSubMenu.add_command(label='Parameter', font='Sans 10 bold', command=self.onLoescheParameter)
        self.loeschenSubMenu.add_command(label=u'Zwischengröße', font='Sans 10 bold', command=self.onLoescheZwischengroesse)
        self.loeschenSubMenu.add_command(label='Wirkung', font='Sans 10 bold', command=self.onLoescheWirkung)
        #### Darstellungs-Menu
        self.darstellungSubMenu = Menu(self.menuBar)
        self.menuBar.add_cascade(label='Darstellung', font='Sans 10 bold', menu=self.darstellungSubMenu)
        self.darstellungSubMenu.add_command(label='Faktoren positionieren', font='Sans 10 bold', command=self.onFaktorPosition)
        self.darstellungSubMenu.add_command(label='ein Element verschieben', font='Sans 10 bold', command=self.onEinenVerschieben)
        self.darstellungSubMenu.add_command(label='mehrere verschieben', font='Sans 10 bold', command=self.onMehrereVerschieben)
        self.darstellungSubMenu.add_command(label='alle verschieben', font='Sans 10 bold', command=self.onAlleVerschieben)
        self.darstellungSubMenu.add_separator()
        self.darstellungSubMenu.add_command(label='Farben festlegen', font='Sans 10 bold', command=self.onFarben)
        self.darstellungSubMenu.add_separator()
        self.darstellungSubMenu.add_command(label='Modellkommentar', font='Sans 10 bold', command=self.onModellkommentar)
        self.darstellungSubMenu.add_command(label='Modelldaten zeigen', font='Sans 10 bold', command=self.onModelldatenZeigen)
        self.darstellungSubMenu.add_command(label='Modelldaten formatiert ausgeben', font='Sans 10 bold', command=self.onModelldatenAusgeben)
        self.darstellungSubMenu.add_command(label='Modelldiagramm speichern', font='Sans 10 bold', command=self.onBild)
        #### Hilfe-Menu
        self.hilfeSubMenu = Menu(self.menuBar)
        self.menuBar.add_cascade(label='Hilfe', font='Sans 10 bold', menu=self.hilfeSubMenu)
        self.hilfeSubMenu.add_command(label='Beispiel zeigen', font='Sans 10 bold', command=self.zeichne_Objekte)
        self.hilfeSubMenu.add_command(label='Hilfe zum Entwickeln', font='Sans 10 bold', command=self.ZeigeHilfeText1)
        self.hilfeSubMenu.add_command(label='Hilfe zu den Dateien', font='Sans 10 bold', command=self.ZeigeHilfeText2)
        self.hilfeSubMenu.add_command(label='Hilfe zu Kurztasten', font='Sans 10 bold', command=self.ZeigeHilfeText3)
        self.hilfeSubMenu.add_command(label='Hilfe zu Mausaktionen', font='Sans 10 bold', command=self.ZeigeHilfeText4)
        self.hilfeSubMenu.add_command(label=u'Hilfe zu Modellfenstervarianten', font='Sans 10 bold', command=self.ZeigeHilfeText5)
        self.hilfeSubMenu.add_command(label='Hilfe zu den Bilddateien', font='Sans 10 bold', command=self.ZeigeHilfeText6)

        ## Anlegen der Attribute
        self.__simulation=Simulation.GibSimulation(self)
        self.__simulation.SetzeView(self)
        self.__click_position = (100,100)
        self.__click_ID = None     # fuer linken Mausklick
        self.__neueWirkung = False # fuer grafische Verknuepfung
        self.__ausgewaehlt = None  # fuer Ziehen mit linker Maustaste gedrueckt
        ## Tk-Variable [Daten für Widgets]
        self.__modellVariable = StringVar()
        self.__modellVariable.set('')
        self.__modellGeaendert=False
        self.__bewegt = False
        self.__aktuellesVerzeichnis = '.'
        ## Definition von Ereignissen fuer das Fenster
        self.winfo_toplevel().bind("<Control-o>", self.onLesen)
        self.winfo_toplevel().bind("<Control-s>", self.onSpeichern)
        self.winfo_toplevel().bind("<Control-d>", self.onModelldatenZeigen)
        self.winfo_toplevel().bind("<Control-p>", self.onBild)
        self.winfo_toplevel().bind("<Alt-n>", self.onNeuesModell)
        self.winfo_toplevel().bind("<Alt-b>", self.onBestand)
        self.winfo_toplevel().bind("<Alt-f>", self.onFluss)
        self.winfo_toplevel().bind("<Alt-p>", self.onParameter)
        self.winfo_toplevel().bind("<Alt-z>", self.onZwischengroesse)
        self.winfo_toplevel().bind("<Alt-w>", self.onWirkung)
        self.winfo_toplevel().bind("<Alt-m>", self.onWirkungMaus)

        ## Oberflaeche erzeugen
        if not self.__scroll: self.grid(sticky=N+S+E+W)
        self.createWidgets()
        if self.__scroll: self.pack() # nur beim Scrollfenster

    def SetzeSimulationsModell(self, dasModell):
        '''Simulationssingleton bekannt machen'''
        self.simu=dasModell
        self.simu.SetzeView(self)
        
    def createWidgets(self):
        '''Einsatz des grid - Geometriemanagers'''
        if not self.__scroll:
            top=self.winfo_toplevel()
            top.rowconfigure(0, weight=1)
            top.columnconfigure(0, weight=1)
            self.rowconfigure(1, weight=1)
            self.columnconfigure(0, weight=1)
        # 1. Zeile
        self.modell_Label = Label(self, text=" Modellname: ", font='Sans 12')
        self.modell_Label.grid(row=0,column=0)
        self.modellNameLabel = Label(self, textvariable=self.__modellVariable,
                                     font='Sans 11 bold italic', width=32,
                                     fg=self.__fg, bg=self.__bg)
        self.modellNameLabel.grid(row=0,column=1)
        self.beenden_Button = Button(self, text="Beenden", font='Sans 10 bold',
                                     command=self.onBeenden)
        self.beenden_Button.grid(row=0,column=2,padx=50)
        # 2. Zeile
        if self.__scroll:
            self.modellFrame=Frame(self)
            self.modellFrame.grid(row=1,column=0, columnspan=3)
            self.zeichenflaeche = Canvas(self.modellFrame,
                                         height=self.hoehe,
                                         width=self.breite,
                                         bg=self.__bg,
                                         scrollregion=(0, 0, 1800, 1200))
            zf=self.zeichenflaeche # lokale Hilfsvariable
            zf.grid(row=0,column=0)
            scrollX=Scrollbar(self.modellFrame,orient=HORIZONTAL,command=zf.xview)
            scrollY=Scrollbar(self.modellFrame,orient=VERTICAL,command=zf.yview)
            scrollX.grid(row=1,column=0, sticky=W+E)
            scrollY.grid(row=0,column=1, sticky=N+S)
            zf['xscrollcommand'] = scrollX.set
            zf['yscrollcommand'] = scrollY.set
        else:
            self.zeichenflaeche = Canvas(self,
                                         height=self.hoehe,
                                         width=self.breite,
                                         bg=self.__bg) ## Original: 'white')
            zf=self.zeichenflaeche # lokale Hilfsvariable
            zf.grid(row=1,column=0, columnspan=3, sticky=N+S+E+W)

        # Binden von Ereignissen an die Zeichenflaeche:
        zf.bind("<Button-1>", self.links_Mausklick)
        zf.bind("<Double-Button-1>", self.links_doppelt)
        zf.bind("<Button-3>", self.rechts_Mausklick)
        zf.bind("<Control-Button-1>", self.rechts_Mausklick)
        zf.bind("<ButtonRelease>", self.links_loslassen)
        zf.bind("<Motion>", self.bewegt)

    #### --------- Dateimenue ------------------------------
    def onLesen(self, evt=None):
        '''Der Modellname wird zwingend aus dem Dateinamen entnommen.'''       
        if len(self.simu.GibAlleFaktorNamen())>0: # 't' nicht enthalten
            dialog=BestaetigungsDialog(self, u'Aktuelles Modell löschen?', 'Wollen Sie das wirklich?')
            if not dialog.result: return
            self.simu.LoescheAktuellesModell()
            CanvasElement.LoescheAlle(self.zeichenflaeche)
            self.__modellVariable.set('')
        dateiname=self.holeDatei()
        if not dateiname:
            return None
        ## Modellnamen extrahieren
        modellName=self.simu.ModellNameAusDateiNamen(dateiname)
        if not(self.SetzeModellNamen(modellName)): return
        self.__modellGeaendert=False        
        ## Daten holt das Modell
        daten=self.simu.Lies(dateiname, namenSetzen=True)
        # Daten werden im Modell initialisiert
        # hier muessen die Werte fuer die Darstellung extrahiert werden
        if daten==None:
            MeldungDialog(self,'Info', 'Keine Daten gelesen!')
            return None
        self.erzeugen(daten)
        ## bei anderem Dateiverzeichnis das Verzeichnis merken:
        verzeichnis=os.path.split(dateiname)[0]
        self.__aktuellesVerzeichnis=verzeichnis

    def onImport(self, evt=None):
        '''Die eingelesenen Faktoren und Wirkungen werden dem
        aktuellen Modell hinzugefügt.'''
        m=MeldungDialog(self,
                        'ACHTUNG',
                        'Nur für den Import in ein vorhandenes Modell!\n\n'+
                        'Wollen Sie das wirklich???\n\n'+
                        'Vermeiden Sie mögliches Überdecken der Elemente,\n'+
                        'indem Sie vorher ggf. alle Elemente verschieben!\n')
        if not m.result: return # abgebrochen
        if self.__modellVariable.get()=='': return None # das ist kein Import
        dateiname=self.holeDatei()
        if not dateiname:
            return None
        daten=self.simu.Lies(dateiname, namenSetzen=False)
        # Daten werden im Modell initialisiert
        # hier muessen die Werte fuer die Darstellung extrahiert werden
        if daten==None:
            MeldungDialog(self,'Info', 'Keine Daten gelesen!')
            return None
        self.erzeugen(daten)

    def holeDatei(self):
        verzeichnis = 'simulationsprojekt/Modelle'
        if self.__aktuellesVerzeichnis!='.':
            verzeichnis = self.__aktuellesVerzeichnis
        dateiname=fileDialog.askopenfilename(parent=self,
                                               defaultextension='simdia',
                                               initialdir=verzeichnis,
                                               title="Modelldaten laden")
        if (dateiname==None) or dateiname==():
            MeldungDialog(self,'Info', 'Keine Daten gelesen!')
            return None
        return dateiname
        
    def erzeugen(self, daten):
        '''Hilfsfunktion für Lesen und Import'''
        zf=self.zeichenflaeche
        for element in daten:
            if element[0]=='Bestand':
                name=element[1]
                try: pos=element[3]
                except IndexError:
                    pos=(randint(100,200),randint(100,200))
                be=BestandsElement(zf,name,pos)
            elif element[0]=='Parameter':
                name=element[1]
                try: pos=element[3]
                except IndexError:
                    pos=(randint(100,200),randint(100,200))
                pa=ParameterElement(self.zeichenflaeche,name,pos)
            elif element[0]=='Zwischengroesse':
                name=element[1]
                try: pos=element[2]
                except IndexError:
                    pos=(randint(100,200),randint(100,200))
                zg=ZwischengroesseElement(self.zeichenflaeche,name,pos)
            elif element[0]=='QuelleSenke':
                elementObjekt=CanvasElement.nameUndElement[element[1]]
                pos=elementObjekt.GibPosition()
                dx,dy=element[2][0]-pos[0],element[2][1]-pos[1]
                if 'Senke_' in element[1]: flussName=element[1][6:]
                elif 'Quelle_' in element[1]: flussName=element[1][7:]
                else: return # Lesefehler?
                self.VerschiebeElement(element[1],dx,dy)
                ##CanvasElement.AktualisiereFluss(zf,flussName)
            elif element[0]=='Fluss':
                name,von,auf=element[1],element[2],element[3]
                if len(element)==5:
                    fl=FlussElement(self.zeichenflaeche, name, von, auf, element[4])
                else:
                    fl=FlussElement(self.zeichenflaeche, name, von, auf)
            elif element[0]=='Wirkung':
                von,auf=element[1],element[2]
                if len(element)>3: orBogString=element[3]
                else: orBogString='1'
                try: orBog=int(orBogString)
                except ValueError as e:
                    orBog=1
                wi=WirkungElement(self.zeichenflaeche, von, auf, orBog)

    def onSpeichern(self, evt=None):
        '''Es wird zunaechst geprueft, ob ein Modellname existiert.'''
        if self.__modellVariable.get()=='':
            self.SetzeModellNamen()
        dateiname=self.__modellVariable.get()+'.simdia'
        verzeichnis = 'simulationsprojekt/Modelle'
        if self.__aktuellesVerzeichnis!='.':
            verzeichnis = self.__aktuellesVerzeichnis
        dateiname=fileDialog.asksaveasfilename(parent=self,
                                                 initialfile=dateiname,
                                                 defaultextension='simdia',
                                                 initialdir=verzeichnis,
                                                 title="Modelldaten speichern")
        if not dateiname:
            MeldungDialog(self,'Info', 'Keine Daten geschrieben!')
            return
        ## bei anderem Dateiverzeichnis das Verzeichnis merken:
        verzeichnis=os.path.split(dateiname)[0]
        self.__aktuellesVerzeichnis=verzeichnis
        self.simu.SichereModellDaten()
        if self.simu.GibModellDaten()==[]:
            MeldungDialog(self,'Info', 'Keine Modelldaten definiert!')
            return
        try:
            daten=self.PositionenEinfuegen(
                self.BogenOrientierungEinfuegen(
                    self.simu.GibModellDaten()))
            self.QuelleSenkeSichern(daten)
            self.simu.Speichere(dateiname,daten)
            self.__modellGeaendert=False
        except Exception as e:
            MeldungDialog(self,'Fehler!', str(e))
            

    def QuelleSenkeSichern(self,daten):
        for name in CanvasElement.nameUndElement:
            element=CanvasElement.nameUndElement[name]
            if element.__class__==QuelleSenke:
                speichern=('QuelleSenke',
                           name,
                           element.GibPosition())
                daten.append(speichern)

    def BogenOrientierungEinfuegen(self, alleDaten):
        datenMit=[]
        for daten in alleDaten:
            if (daten[0]=='Wirkung'):
                we=CanvasElement.ObjektZuTag(daten[1]+'->'+daten[2])
                orBog=we.GibBogenOrientierung()
                datenMit.append((daten[0],daten[1],daten[2],orBog))
            else:
                datenMit.append(daten)
        return datenMit

    def PositionenEinfuegen(self, alleDaten):
        zf=self.zeichenflaeche
        datenMitPositionen=[]
        for daten in alleDaten:
            if (daten[0]=='Bestand'):
                x,y,xe,ye=zf.coords(daten[1])
                datenMitPositionen.append((daten[0],daten[1],daten[2],(x,y)))
            elif (daten[0]=='Parameter'):
                ## Problem Position
                x,y,xe,ye=zf.coords(daten[1])
                datenMitPositionen.append((daten[0],daten[1],daten[2],(x,y)))
            elif (daten[0]=='Zwischengroesse'):
                ## Problem Position
                x,y,xe,ye=zf.coords(daten[1])
                datenMitPositionen.append((daten[0],daten[1],(x,y)))
            else:
                datenMitPositionen.append(daten)
        return datenMitPositionen
        
    def SetzeModellNamen(self, modellName=''):
        if modellName=='': # aus dem Menue aufgerufen
            dialog=EingabeDialog(self, u'Modellnamen wählen', 'Namen eingeben')
            if dialog.result==None: return # cancel ausgewaehlt
            modellName=dialog.result
##        if self.__modellVariable.get()!='':
##            if self.__modellVariable.get()!=modellName:
##                dialog=BestaetigungsDialog(self,
##                                           u'Modellwechsel?',
##                                           'Wollen Sie das wirklich?')
##                if not dialog: return False
        self.__modellVariable.set(modellName)
        return True

##    wird das noch gebraucht ???
    def onHome(self):
        self.__aktuellesVerzeichnis = os.environ["HOME"]
        os.chdir(os.environ["HOME"])

    def onVerzeichnis(self):
        self.__aktuellesVerzeichnis='.'

    def onBeenden(self):
        '''Verhindert unbeabsichtigtes Schliessen.
        Leider nicht gefunden, wie die Fenster-Schliessen-Methode
        ueberschrieben werden kann'''
        if self.__modellGeaendert==False: self.quit()
        else:
            antwort=tkmessagebox.askokcancel('Sicherheitsabfrage !','Wirklich beenden?',icon='warning')
            if antwort: self.quit()

    #### ---------- Modellentwicklungs-Menue -------------------------------------
    def onNeuesModell(self, evt=None):
        '''Strategie:
        - noch kein Name und kein Modell: -> Namen festlegen
        - vorhandenes Modell mit neuem Namen: -> Abfrage, ob gewollt'''
        if (len(self.simu.GibAlleFaktorNamen())<=1) and (self.__modellVariable.get()==''): # mehr als t
            self.SetzeModellNamen()
            return
        dialog=BestaetigungsDialog(self, u'Aktuelles Modell löschen?', 'Wollen Sie das wirklich?')
        if dialog.result==None:
            MeldungDialog(self,'Ergebnis :','abgebrochen')
            return
        if dialog.result==True:
            self.simu.LoescheAktuellesModell()
            CanvasElement.LoescheAlle(self.zeichenflaeche)
            self.__modellVariable.set('')
        dialog=EingabeDialog(self, u'Neuer Name für das Modell', 'Namen eingeben')
        name=dialog.result
        if dialog.result==None: return # cancel ausgewaehlt
        self.__modellGeaendert=True
        self.__modellVariable.set(name)
    
    def onBestand(self, evt=None):
        dialog=EingabeDialog(self, 'neuer Bestand', 'Namen eingeben')
        name=dialog.result
        if dialog.result==None: return # cancel ausgewaehlt
        dialog=EingabeDialog(self, 'Anfangsbestand', 'Zahl eingeben')
        if dialog.result==None: return # cancel ausgewaehlt
        startwert=string_in_Zahl(dialog.result)
        faktor=self.simu.NeuerBestandsfaktor(name,startwert)
        if faktor!=None:
            be=BestandsElement(self.zeichenflaeche,name)
            self.__modellGeaendert=True

    def onParameter(self, evt=None):
        dialog=EingabeDialog(self, 'neuer Parameter', 'Namen eingeben')
        name=dialog.result
        if dialog.result==None: return # cancel ausgewaehlt
        dialog=EingabeDialog(self, 'Wert angeben', 'Zahl eingeben')
        if dialog.result==None: return # cancel ausgewaehlt
        startwert=string_in_Zahl(dialog.result)        
        faktor=self.simu.NeuerParameter(name,startwert)
        if faktor!=None:
            pa=ParameterElement(self.zeichenflaeche,name)
            self.__modellGeaendert=True
            
    def onZwischengroesse(self, evt=None):
        dialog=EingabeDialog(self, u'neue Zwischengröße', 'Namen eingeben')
        name=dialog.result
        if dialog.result==None: return # cancel ausgewaehlt
        faktor=self.simu.NeueZwischengroesse(name)
        if faktor!=None:
            zg=ZwischengroesseElement(self.zeichenflaeche,name)
            self.__modellGeaendert=True

    def onFluss(self, evt=None):
        '''Fluesse nur zwischen Bestandsfaktoren'''
        # Ausgang und Ziel holen
        bestaendeNamen=self.simu.GibFaktorNamen('Bestandsfaktor')
        vonDialog=AuswahlDialog(self,'Fluss: Ausgangsfaktor wählen',bestaendeNamen+['Quelle'],True)
        if vonDialog.result==None: return # bei cancel None
        von=vonDialog.result
        if not von: return
        aufDialog=AuswahlDialog(self,'Fluss: Zielfaktor wählen',bestaendeNamen+['Senke'],True)
        if aufDialog.result==None: return # bei cancel None
        auf=aufDialog.result
        if not auf: return
        if (von=='Quelle') and (auf=='Senke'): return # Fehler!
        dialog=EingabeDialog(self, 'Fluss', von+'->'+auf+'\nNamen eingeben')
        if dialog.result==None: return # cancel ausgewaehlt
        name=dialog.result
        if not name: return
        fluss=self.simu.NeuerFluss(name, von, auf)
        fl=FlussElement(self.zeichenflaeche, name, von, auf)
        self.__modellGeaendert=True
        
    def onWirkung(self, evt=None):
        vonDialog=AuswahlDialog(self,'Ausgangsfaktor wählen',self.simu.GibAlleFaktorNamen(),True)
        if vonDialog.result==None: return # bei cancel None
        von=vonDialog.result
        ziele=[]+self.simu.GibFaktorNamen('Fluss')+self.simu.GibFaktorNamen('Zwischengroesse')
        if von in ziele: ziele.remove(von)
        aufDialog=AuswahlDialog(self,
                                'Zielfaktor wählen',
                                ziele,
                                True)
        if aufDialog.result==None: return # bei cancel None
        auf=aufDialog.result
        wirkung=self.simu.NeueWirkung(von, auf)
        wi=WirkungElement(self.zeichenflaeche, von, auf)
        self.__modellGeaendert=True

    def onWirkungMaus(self, evt=None):
        '''Wirkung mit Maus:
        Ausgangsfaktor anklicken, Maus zu Zielfaktor ziehen
        Aktion wird bei der Mausbehandlung realisiert'''
        self.__neueWirkung = True        

    #### ----------- Bearbeiten-Menu ----------------------------------------
    def onBestandBearbeiten(self, bestandsName=None):
        bestand=self.HoleFaktor('Bestandsfaktor', bestandsName)
        if bestand==None: return False # cancel angeklickt
        werte=self.HoleWerte(u'Bestandsfaktor ändern',
                             ['Bestand','Wert'],
                             [bestand.GibNamen(),str(bestand.GibStartwert())])
        if werte==None: return False # cancel angeklickt
        if bestand.GibNamen()!=werte[0]:
            self.NeuerFaktorName(bestand,werte[0])
            self.__modellGeaendert=True
        if str(bestand.GibStartwert())!=werte[1]:
            self.NeuerStartwert(bestand,string_in_Zahl(werte[1]))
            self.__modellGeaendert=True
        return True

    def onFlussBearbeiten(self, flussName=None):
        fluss=self.HoleFaktor('Fluss', flussName)
        if fluss==None: return False # cancel angeklickt
        werte=self.HoleWerte(u'Fluss ändern',
                             ['Name','Term'],
                             [fluss.GibNamen(),fluss.GibTerm()],
                             30) # Eingabefeld breiter
        if werte==None: return False # cancel angeklickt
        if fluss.GibNamen()!=werte[0]:
            if not(self.NeuerFaktorName(fluss,werte[0])):
                return False
        if fluss.GibTerm()!=werte[1]:
            ok=False
            while not ok:
                ok=fluss.SetzeTerm(werte[1])
                if not ok:
                    werte=self.HoleWerte(u'Fluss ändern',
                                         ['Name','Term'],
                                         [fluss.GibNamen(),werte[1]],
                                         30) # Eingabefeld breiter
                    if werte==None: return False # cancel angeklickt        
        self.__modellGeaendert=True
        return True

    def onParameterBearbeiten(self, parameterName=None):
        parameter=self.HoleFaktor('Parameter', parameterName)
        if parameter==None: return False # cancel angeklickt
        if parameter.GibTerm()==None:
            werte=self.HoleWerte(u'Parameter ändern',
                                 ['Name','Startwert'],
                                 [parameter.GibNamen(),str(parameter.GibStartwert())])
            if werte==None: return False # cancel angeklickt
            if parameter.GibNamen()!=werte[0]:
                self.NeuerFaktorName(parameter,werte[0])
                self.__modellGeaendert=True
            if str(parameter.GibStartwert())!=werte[1]:
                if parameter.GibTabelle()!=None:
                    abfrage=BestaetigungsDialog(self,
                                            u'Parameter hat Werte als Tabelle',
                                            'Tabelle löschen?')
                    if abfrage.result in [False, None]:
                        self.onTabelleneingabe(auswahl)
                        return
                self.NeuerStartwert(parameter,string_in_Zahl(werte[1]))
                self.__modellGeaendert=True
        else:
            werte=self.HoleWerte(u'Parameter ändern',
                                 ['Name','Term'],
                                 [parameter.GibNamen(),parameter.GibTerm()])
            if werte==None: return False # cancel angeklickt
            if parameter.GibNamen()!=werte[0]:
                self.NeuerFaktorName(parameter,werte[0])
                self.__modellGeaendert=True
            if parameter.GibTerm()!=werte[1]:
                self.NeuerTerm(parameter,werte[1])
                self.__modellGeaendert=True
        return True

    def onZwischengroesseBearbeiten(self, zwischengroesseName=None):
        zg=self.HoleFaktor('Zwischengroesse', zwischengroesseName)
        if zg==None: return False # cancel angeklickt
        werte=self.HoleWerte(u'Zwischengröße ändern',
                             ['Name','Term'],
                             [zg.GibNamen(),zg.GibTerm()],
                             30) # Eingabefeld breiter
        if werte==None: return False # cancel angeklickt
        if zg.GibNamen()!=werte[0]:
            self.NeuerFaktorName(zg,werte[0])
            self.__modellGeaendert=True
        if zg.GibTerm()!=werte[1]:
            ok=False
            while not ok:
                ok=zg.SetzeTerm(werte[1])
                if not ok:
                    werte=self.HoleWerte(u'Zwischengröße ändern',
                                         ['Name','Term'],
                                         [zg.GibNamen(),werte[1]],
                                         30) # Eingabefeld breiter
                    if werte==None: return False # cancel an geklickt        
            self.__modellGeaendert=True
        return True
        
    def onTermBearbeiten(self):
        '''Terme gibt es nicht bei Bestandsgroessen,
        Parameter haben keine Eingaenge'''
        namen=[]+self.simu.GibFaktorNamen('Fluss')
        namen+=self.simu.GibFaktorNamen('Zwischengroesse')
        parameterNamen=self.simu.GibFaktorNamen('Parameter')
        dialog1=AuswahlDialog(self,u'Faktor wählen',namen+parameterNamen, True)
        if dialog1.result==None: return False # cancel angeklickt
        auswahl=dialog1.result
        self.termBearbeiten(auswahl) ## wegen Auswahl durch doppelten Mausklick

    def termBearbeiten(self, auswahl):
        faktor=Faktor.FaktorZuNamen(auswahl)
        if faktor==None: return
        if faktor.HatTabelle():
            abfrage=BestaetigungsDialog(self,
                                    u'Parameter hat Werte als Tabelle',
                                    'Tabelle löschen?')
            if abfrage.result in [False, None]:
                self.onTabelleneingabe(auswahl)
                return
            else:
                self.onLoescheTabelle(auswahl)
                if parameter.GibTabelle()!=None:
                    return  # Tabelle nicht geloescht -> Abbruch
        term=faktor.GibTerm()
        if term==None: term=0.0
        dialog=TermEingabeDialog(self, auswahl, 'Term', term)
        if dialog.result==None: return False # cancel an geklickt
        neuerTerm=dialog.result
        if term!=neuerTerm:
            if not faktor.SetzeTerm(neuerTerm): # einmaliger Korrekturversuch
                werte=self.HoleWerte(u'Term ändern',
                                     ['Name','Term'],
                                     [faktor.GibNamen(),neuerTerm],
                                     30) # Eingabefeld breiter
                if werte==None: return False # cancel an geklickt
                if not faktor.SetzeTerm(werte[1]):
                    return False # endgueltiger Abbruch
        self.__modellGeaendert=True
        return True

    def onWirkungBearbeiten(self, evt=None):
        alle=Wirkung.GibAlleWirkungen()
        namen=[]
        for wirkung in alle:
            namen.append(wirkung.GibVon()+'->'+wirkung.GibAuf())
        auswahlDialog=AuswahlDialog(self, 'Wirkung wählen', namen, True) # nur eine!
        if not(auswahlDialog.result): return
        name=auswahlDialog.result
        von,pfeil,auf=name.partition('->')
        wirkung=Wirkung.HatWirkung(von,auf)
        if not(wirkung): return # sollte nicht passieren
        we=CanvasElement.ObjektZuTag(name)
        bogenOrientierung=we.GibBogenOrientierung()
        dialog=EingabeDialog(self,"Bogenorientierung",
                             'weiter: >1, enger <1 , für Wechsel +/-',
                             bogenOrientierung)
        if not(dialog.result):
            wert=bogenOrientierung
        else:
            try:
                wert=int(dialog.result)
            except ValueError as e:
                try:
                    wert=float(dialog.result)
                except ValueError as e:
                    return
        CanvasElement.AktualisiereWirkung(self.zeichenflaeche, von, auf, wert)

    def onPfeileAktualisieren(self):
        '''Nach dem Verschieben von Elementen muessen ggf Wirkungs-Pfeile
        und Fluss-Pfeile aktualisiert werden'''
        CanvasElement.AktualisiereAllePfeile(self.zeichenflaeche)
    
    #### Hilfsmethoden dafuer
    def HoleFaktor(self, typ, faktorName):
        if faktorName==None:
            faktorName=self.FaktorWaehlenDialog(typ)
        if faktorName==None: return None # cancel an geklickt
        return Faktor.FaktorZuNamen(faktorName)
    
    def HoleWerte(self, titel, labelListe, inhaltListe, spezielleBreite=20):
        dialog=N_EingabenDialog(self,titel,labelListe, inhaltListe, spezielleBreite)
        if dialog.result==None: return None # cancel an geklickt
        return dialog.result[0],dialog.result[1]
        
    def NeuerFaktorName(self,faktor,neuerName):
        '''aendert bei neuem Namen den Faktornamen und gibt True zurueck'''
        alterName=faktor.GibNamen()
        if neuerName==alterName: return False
        if not(self.simu.AendereFaktorNamen(alterName, neuerName)):
            return False
        ## Alle ueber die Namensaenderung informieren
        CanvasElement.AendereNamen(self.zeichenflaeche,alterName,neuerName)
        return True
        
    def NeuerStartwert(self, faktor, startwert):
        if startwert!=faktor.GibStartwert():
            faktor.SetzeStartwert(startwert)

    def NeuerTerm(self, faktor, term):
        if term!=faktor.GibTerm():
            faktor.SetzeTerm(term)
        
#### ---------- Tabellen-Menue ------------------------------------
    def onTabelleNeu(self):
        auswahl=self.FaktorWaehlenDialog(['Parameter','Zwischengroesse'])
        if auswahl==None: return # cancel angeklickt
        faktor=Faktor.FaktorZuNamen(auswahl)
        faktor.NeueTabelle()
        return True

    def onTabelleAnzeigen(self):
        '''Tabelle anzeigen'''
        auswahl=self.FaktorWaehlenDialog(['Parameter','Zwischengroesse'])
        if auswahl==None: return False # cancel angeklickt
        faktor=Faktor.FaktorZuNamen(auswahl)
        if faktor.GibTabelle()==None:
            MeldungDialog(self,'Achtung!','Parameterwert ist konstant oder Term!')
            return False
        tabellenWerte=faktor.GibTabellenWerte() # Paar von (Liste-Stellen (Zeiten) , Liste-Werte)
        if faktor.__class__==Zwischengroesse:
            ausgabeTabelle=[[faktor.GibTabellenWirkFaktor(),auswahl]] 
        else:
            ausgabeTabelle=[['t',auswahl]]
        for i in range(len(tabellenWerte[0])):
            ausgabeTabelle.append([str(tabellenWerte[0][i]),str(tabellenWerte[1][i])])
        dialog=TabellenAusgabeDialog(self,
                                     u'Tabellenausgabe',
                                     ausgabeTabelle)
        return True

    def onTabelleneingabe(self, auswahl=None): # auswahl bekannt, wenn intern aufgerufen
        if auswahl==None:
            faktorNamen=self.HoleFaktorenMitTabelle()
            dialog=AuswahlDialog(self, u'Faktor wählen', faktorNamen, True)
            auswahl=dialog.result
            if auswahl==None: return False # cancel angeklickt
        faktor=Faktor.FaktorZuNamen(auswahl)
        if faktor.GibTabelle()==None:
            MeldungDialog(self,'Achtung!',
                          'Parameterwert ist konstant oder Term!\n'+
                          'Tabelle vorher anlegen.')
            return False
        tabellenWerte=faktor.GibTabellenWerte() # Paar von Liste Zeiten / Liste Werte
        dialog=TabellenEingabeDialog(self, "Tabellenwerte "+auswahl,
                                             ['t',auswahl],tabellenWerte[0],tabellenWerte[1])
        if dialog.result==None: return False
        zeitenStrings,werteStrings=dialog.result
        zeiten, werte=[],[]
        try:
            for i in range(len(zeitenStrings)):
                zeiten.append(float(zeitenStrings[i]))
                werte.append(float(werteStrings[i]))
                if float(zeitenStrings[i])==0.0:
                    faktor.SetzeStartwert(float(werteStrings[i]))
        except ValueError as e:
            self.Meldung("Fehler bei den Eingaben")
            return False
        faktor.SetzeTabellenWerte(zeiten, werte)
        self.__modellGeaendert=True
        return True
        
    def onInterpolierenAn(self):
        self.TabelleInterpolieren(True)

    def onInterpolierenAus(self):
        self.TabelleInterpolieren(False)

    def TabelleInterpolieren(self, interpolieren=True):
        namen=self.HoleFaktorenMitTabelle()
        dialog=AuswahlDialog(self,'Faktor wählen',namen,True)
        if dialog.result==None: return # kein Parameter gewaehlt
        name=dialog.result
        faktor=Faktor.FaktorZuNamen(name)
        faktor.GibTabelle().SetzeInterpolieren(interpolieren)
        self.__modellGeaendert=True

    def onLoescheTabelle(self, parameterName=None):
        if parameterName==None:
            parameterDialog=AuswahlDialog(self,
                                          'Parameter wählen',
                                          self.simu.GibFaktorNamen('Parameter'),
                                          True)
            if parameterDialog.result==None:
                return False # kein Parameter gewaehlt
            parameterName=parameterDialog.result
        parameter=Faktor.FaktorZuNamen(parameterName)
        parameter.LoescheTabelle()
        self.__modellGeaendert=True
        return True

    def HoleFaktorenMitTabelle(self):
        namen=self.simu.GibAlleFaktorNamen()
        habenTabelle=[]
        for name in namen:
            if Faktor.FaktorZuNamen(name).HatTabelle():
                habenTabelle.append(name)
        return habenTabelle
        
    def onTabelleAnzeigen(self):
        '''Tabelle anzeigen'''
        namen=self.HoleFaktorenMitTabelle()
        dialog=AuswahlDialog(self,'Faktor wählen',namen,True)
        if dialog.result==None: return False # kein Parameter gewaehlt
        auswahl=dialog.result
        faktor=Faktor.FaktorZuNamen(auswahl)
        tabellenWerte=faktor.GibTabellenWerte()
        if faktor.__class__==Parameter:  # Paar von Liste Zeiten / Liste Werte
            ausgabeTabelle=[['t',auswahl]]
        else:
            if faktor.GibTabellenWirkFaktorNamen()==None:
                self.Meldung('Fehler bei Wirkfaktor')
                return
            ausgabeTabelle=[[faktor.GibTabellenWirkFaktorNamen(),auswahl]]
        for i in range(len(tabellenWerte[0])):
            ausgabeTabelle.append([str(tabellenWerte[0][i]),str(tabellenWerte[1][i])])
        dialog=TabellenAusgabeDialog(self,
                                     u'Tabellenausgabe',
                                     ausgabeTabelle)
        return True


#### ---------- Loeschen-Menue ------------------------------------
    def onLoescheBestand(self):
        bestandDialog=AuswahlDialog(self,
                                'Bestandsfaktor wählen',
                                self.simu.GibFaktorNamen('Bestandsfaktor'),
                                True)
        if bestandDialog.result==None: return # bei cancel None
        bestand=bestandDialog.result
        # Quellen/Senken von Fluessen zu dem Bestand muessen aus
        # der Darstellung entfernt werden:
        bestandsFaktor=Faktor.FaktorZuNamen(bestand)
        fluesseNamen=bestandsFaktor.GibZuFluesse()+bestandsFaktor.GibAbFluesse()
        fluesse=[]
        for name in fluesseNamen:
            flussElement=CanvasElement.ObjektZuTag(name)
            quelleSenke=flussElement.gibQuelleSenke()
            if quelleSenke!=None:
                CanvasElement.LoescheElement(self.zeichenflaeche,quelleSenke)
        # Bestandsobjekt loeschen
        self.simu.LoescheBestandsfaktor(bestand)
        self.__modellGeaendert=True
        for geloescht in self.simu.HoleGeloeschte():
            CanvasElement.LoescheElement(self.zeichenflaeche,
                                         CanvasElement.ObjektZuTag(geloescht))
        
    def onLoescheFluss(self):
        flussDialog=AuswahlDialog(self,
                                'Fluss wählen',
                                self.simu.GibFaktorNamen('Fluss'),
                                True)
        if flussDialog.result==None: return # bei cancel None
        fluss=flussDialog.result
        # Die Wirkungen auf den Fluss muessen zunaechst geloescht werden.
        # Die Modellklasse regelt das, aber auch die Modellfensterelemente
        # muessen entfernt werden.
        for wirkung in self.simu.GibWirkungen():
            von,auf=wirkung.GibVon(),wirkung.GibAuf()
            if fluss in (von,auf):
                CanvasElement.LoescheElement(self.zeichenflaeche,
                                             CanvasElement.ObjektZuTag(von+'->'+auf))
        self.simu.LoescheFluss(fluss)
        flussElement=CanvasElement.ObjektZuTag(fluss)
        quelleSenke=flussElement.gibQuelleSenke()
        if quelleSenke!=None:
            CanvasElement.LoescheElement(self.zeichenflaeche,quelleSenke)
        self.__modellGeaendert=True
        for geloescht in self.simu.HoleGeloeschte():
            CanvasElement.LoescheElement(self.zeichenflaeche,
                                         CanvasElement.ObjektZuTag(geloescht))
        
    def onLoescheParameter(self):
        parameterDialog=AuswahlDialog(self,
                                'Parameter wählen',
                                self.simu.GibFaktorNamen('Parameter'),
                                True)
        if parameterDialog.result==None: return # bei cancel None
        parameter=parameterDialog.result
        self.simu.LoescheParameter(parameter)
        self.__modellGeaendert=True
        for geloescht in self.simu.HoleGeloeschte():
            CanvasElement.LoescheElement(self.zeichenflaeche,
                                         CanvasElement.ObjektZuTag(geloescht))
        
    def onLoescheZwischengroesse(self):
        zgDialog=AuswahlDialog(self,
                                u'Zwischengröße wählen',
                                self.simu.GibFaktorNamen('Zwischengroesse'),
                                True)
        if zgDialog.result==None: return # bei cancel None
        zg=zgDialog.result
        self.simu.LoescheZwischengroesse(zg)
        self.__modellGeaendert=True
        for geloescht in self.simu.HoleGeloeschte():
            CanvasElement.LoescheElement(self.zeichenflaeche,
                                         CanvasElement.ObjektZuTag(geloescht))
        
    def onLoescheWirkung(self):
        wirkungen=Wirkung.GibAlleWirkungen()
        wirkungsTexte=[]
        for wirkung in wirkungen:
            wirkungsTexte.append(wirkung.GibVon()+'->'+wirkung.GibAuf())
        dialog=AuswahlDialog(self,'Wirkung wählen',wirkungsTexte,True)
        if dialog.result==None: return # bei cancel None
        von,symbol,auf=dialog.result.partition('->')
        self.simu.LoescheWirkung(von,auf)
        CanvasElement.LoescheElement(self.zeichenflaeche,
                                     CanvasElement.ObjektZuTag(dialog.result))
        self.__modellGeaendert=True
        MeldungDialog(self,'Achtung!', 'Term in '+auf+u' ändern!')
        
    #### ---------- Darstellungs-Menue -------------------------------------
    def onFaktorPosition(self, evt=None):
        daten = CanvasElement.GibAlleFaktorNamenMitPosition()
        dialog=AuswahlDialog(self, 'Auswahl des Faktors', daten, True)
        if dialog.result==None: return # bei cancel None
        eingabe=N_EingabenDialog(self,
                                dialog.result[0],
                                ['x','y'],
                                [dialog.result[1],dialog.result[2]])
        if eingabe.result==None: return # bei cancel None
        try:
            xNeu,yNeu=float(eingabe.result[0]),float(eingabe.result[1])
            x,y=float(dialog.result[1]),float(dialog.result[2])
        except ValueError as e:
            self.Meldung('falsche Eingabe\n('+str(e)+')','ACHTUNG!')
            return
        self.VerschiebeElement(dialog.result[0], xNeu-x, yNeu-y)

    def onAlleVerschieben(self, evt=None):
        wieWeit=self.WieWeit()
        if not wieWeit: return
        dx,dy=wieWeit
        for name in self.AlleNamenHolen():
            element=CanvasElement.nameUndElement[name]
            self.VerschiebeElement(name, dx, dy)

    def onMehrereVerschieben(self, evt=None):
        namen=self.ElementeWaehlen(nurEinen=False)
        if not namen: return
        wieWeit=self.WieWeit()
        if not wieWeit: return
        dx,dy=wieWeit
        for name in namen:
            element=CanvasElement.nameUndElement[name]
            self.VerschiebeElement(name, dx, dy)

    def onEinenVerschieben(self, evt=None):
        '''Version ohne Maus'''
        name=self.ElementeWaehlen(nurEinen=True)
        if not name: return
        wieWeit=self.WieWeit()
        if not wieWeit: return
        dx,dy=wieWeit
        self.VerschiebeElement(name, dx, dy)

    def AlleNamenHolen(self):
        namen=[]
        for name in CanvasElement.nameUndElement:
            element=CanvasElement.nameUndElement[name]
            if element.__class__ in (BestandsElement,
                                     ParameterElement,
                                     ZwischengroesseElement,
                                     QuelleSenke):
                namen.append(name)
        return namen

    def ElementeWaehlen(self, nurEinen):
        namen=self.AlleNamenHolen()
        auswahl=AuswahlDialog(self, 'Element wählen', namen,einzeln=nurEinen)
        return auswahl.result # kann None sein!

    def WieWeit(self):
        eingabe=N_EingabenDialog(self,
                                'Wie weit ...',
                                ['nach rechts','nach unten'],
                                ['0','0'])
        if not eingabe.result: return None
        try:
            dx,dy=int(eingabe.result[0]),int(eingabe.result[1])
            return dx,dy
        except ValueError as e:
            try:
                dx,dy=float(eingabe.result[0]),float(eingabe.result[1])
                return dx,dy
            except ValueError as ee:
                self.Meldung('falsche Eingabe:\n '+eingabe.result,'ACHTUNG!')
                return None
        

    def onModelldatenZeigen(self, evt=None):
        self.simu.SichereModellDaten()
        zeilen=self.simu.ZeigeModellDaten()
        dialog=TextAusgabeDialog(self,
                                 'Modelldaten',
                                 self.__modellVariable.get(),
                                 zeilen)
    
    def onModellkommentar(self, evt=None):
        zeilen=self.simu.GibModellkommentar()
        dialog=TextEingabeDialog(self,
                                 'Modellkommentar '+
                                 self.__modellVariable.get(),
                                 '',
                                 zeilen)
        if not(dialog.result): return # Abbruch
        liste=dialog.result.split('\n')
        while len(liste)>0 and liste[len(liste)-1]=='':
            liste=liste[:len(liste)-1]
        self.simu.SetzeModellkommentar(liste)
    
    def onModelldatenAusgeben(self, evt=None):
        self.simu.SichereModellDaten()
        zeilen=self.simu.ZeigeModellDaten()
        dateinameVorgabe="Modelldaten_"+self.__modellVariable.get()+".txt"
        dateiname=fileDialog.asksaveasfilename(parent=self,
                                                 initialfile=dateinameVorgabe,
                                                 defaultextension='txt',
                                                 initialdir='simulationsprojekt/Modelldaten',
                                                 title="Modelldaten ausgeben")
        if (dateiname==None) or dateiname==() or dateiname=='':
            MeldungDialog(self,'Info', 'Keine Daten geschrieben!')
            return
        else:
            ausgabe="Modell: "+self.__modellVariable.get() +"\n\n"
            for zeile in zeilen:
                ausgabe+=zeile+'\n'
            try:
                f=open(dateiname,'w')
                f.write(str(ausgabe))
                f.close()
            except IOError as e:
                self.Meldung('Fehler beim Schreiben: '+str(e))
        
    def onBild(self, evt=None):
        dateiname="Modelldiagramm_"+self.__modellVariable.get()+".ps"
        dateiname=fileDialog.asksaveasfilename(parent=self,
                                                 initialfile=dateiname,
                                                 defaultextension='ps',
                                                 initialdir='simulationsprojekt/Bilder',
                                                 title="Modelldiagramm speichern")
        if (dateiname==None) or dateiname==() or dateiname=='':
            MeldungDialog(self,'Info', 'Keine Daten geschrieben!')
            return
        else:
            self.zeichenflaeche.postscript(file=dateiname)

    def onFarben(self, evt=None):
        '''Farben der Elemente können vom Standard (s/w) abweichen'''
        dialog=N_EingabenDialog(self,
                                'Farben (englisch) oder z.B. RGB-Hex-Werte #cfc',
                                ['Bestand','Parameter','Zwischengroesse','Fluss','Wirkung'],
                                CanvasElement.farben,
                                40)
        if not dialog.result: return
        farbliste=dialog.result
        # Farbnamen testen
        zf=self.zeichenflaeche
        try:
            ID=zf.create_line(0,0,3,3,5,5, fill=farbliste[0])
            zf.delete(ID)
            ID=zf.create_line(0,0,3,3,5,5, fill=farbliste[1])
            zf.delete(ID)
            ID=zf.create_line(0,0,3,3,5,5, fill=farbliste[2])
            zf.delete(ID)
            ID=zf.create_line(0,0,3,3,5,5, fill=farbliste[3])
            zf.delete(ID)
            ID=zf.create_line(0,0,3,3,5,5, fill=farbliste[4])
            zf.delete(ID)
        except Exception as e:
            MeldungDialog(self, 'Achtung!', str(e)+' falscher Farbname in '+str(farbliste))
            return
        CanvasElement.FarbenFestlegen(farbliste)

        
    #### Mausereignisse  ----------------------------------------------
    def links_Mausklick(self, event):
        self.__click_position = (event.x,event.y)
        zf = self.zeichenflaeche
        ID = zf.find_closest(event.x, event.y)
        if ID==(): return # keine Elemente vorhanden
        if CanvasElement.IstFigurID(ID[0]): # keine Klicks auf Texte
            self.__click_ID = ID[0]
            tag=zf.gettags(self.__click_ID)[0]
            element=CanvasElement.ObjektZuTag(tag)
            if element.__class__==FlussElement:
                fluss=element.name
                CanvasElement.AktualisiereFluss(zf,fluss)
            else:
                self.__ausgewaehlt=tag

    def links_doppelt(self, event):
        '''Terme bearbeiten, bei Wirkungen Darstellung aktualisieren'''
        zf = self.zeichenflaeche
        ID = zf.find_closest(event.x, event.y)
        if ID==(): return # keine Elemente vorhanden
        if CanvasElement.IstFigurID(ID[0]): # keine Klicks auf Texte
            self.__click_ID = ID[0]
            tag=zf.gettags(self.__click_ID)[0]
            element=CanvasElement.ObjektZuTag(tag)
            if element.__class__==WirkungElement:
                von,auf=element.von,element.auf
                CanvasElement.AktualisiereWirkung(zf,von,auf)
                return # keine Terme bei Wirkungen
            elif element.__class__==BestandsElement:
                return # keine Terme bei Bestandsfaktoren
            elif element.__class__==ParameterElement:
                ## Parameter hat noch keinen Term
                faktor=Faktor.FaktorZuNamen(tag)
                if faktor.GibTerm()==None:
                    faktor.SetzeTerm(str(faktor.GibStartWert()))
            self.termBearbeiten(tag)

    def rechts_Mausklick(self, event):
        zf = self.zeichenflaeche
        ID = zf.find_closest(event.x, event.y)
        if ID==(): return # keine Elemente vorhanden
        if CanvasElement.IstFigurID(ID[0]): # keine Klicks auf Texte
            rechtsklick=zf.gettags(ID[0])[0]
            if '->' in rechtsklick:
                von,pfeil,auf=rechtsklick.partition('->')
                we=CanvasElement.ObjektZuTag(rechtsklick)
                orBog=-1*we.GibBogenOrientierung()
                CanvasElement.LoescheElement(zf, we)
                WirkungElement(zf, von, auf, orBog)
                return
            else:
                faktor=Faktor.FaktorZuNamen(rechtsklick)
                if faktor.__class__==Bestandsfaktor:
                    self.onBestandBearbeiten(rechtsklick)
                elif faktor.__class__==Fluss:
                    self.onFlussBearbeiten(rechtsklick)
                elif faktor.__class__==Parameter:
                    self.onParameterBearbeiten(rechtsklick)
                elif faktor.__class__==Zwischengroesse:
                    self.onZwischengroesseBearbeiten(rechtsklick)
            
            
    def links_loslassen(self, event):
        zf = self.zeichenflaeche
        if self.__click_ID==None: return # keines ausgewaehlt
        if zf.gettags(self.__click_ID) not in ((),None):
            ## erster Abschnitt fuer das Zeichnen einer Wirkung mit der Maus
            ID = zf.find_closest(event.x, event.y)
            if ID==(): return # keine Elemente vorhanden
            if self.__neueWirkung:
                if CanvasElement.IstFigurID(ID[0]): # keine Klicks auf Texte
                    von=zf.gettags(self.__click_ID)[0]
                    auf=zf.gettags(ID[0])[0]
                    if von==auf: return
                    if self.simu.NeueWirkung(von, auf)!=None:
                        WirkungElement(zf, von, auf)
                        self.__modellGeaendert=True
        self.__ausgewaehlt = None
        self.__click_ID = None
        self.__neueWirkung = False

    def bewegt(self, event):
        if self.__neueWirkung: return
        if self.__click_ID == None: return
        umX, umY = event.x - self.__click_position[0], event.y - self.__click_position[1]
        if self.__ausgewaehlt:
            if CanvasElement.IstFigurTag(self.__ausgewaehlt): # Mehrfachzugriffe vermeiden
                self.VerschiebeElement(self.__ausgewaehlt, umX, umY)
        self.__click_position = (event.x,event.y)
    
    def VerschiebeElement(self, auswahl, umX, umY):
        zf=self.zeichenflaeche
        zf.move(auswahl, umX, umY)
        objekt=CanvasElement.ObjektZuTag(auswahl)
        objekt.x=objekt.x+umX
        objekt.y=objekt.y+umY
        if not '->' in auswahl:
            CanvasElement.AktualisiereAllePfeile(zf)

    #### ------------------------------------------------------------------------
    def FaktorWaehlenDialog(self, faktorTyp=None):
        if type(faktorTyp) is list:
            faktorNamen=[]
            for typ in faktorTyp:
                faktorNamen+=self.simu.GibFaktorNamen(typ)
        else:
            faktorNamen=self.simu.GibFaktorNamen(faktorTyp)
        dialog=AuswahlDialog(self,u'Faktor wählen',faktorNamen, True)
        return dialog.result # bei cancel None
        
    def FaktorenAuswahlDialog(self, faktorTyp=None):
        faktorNamen=self.simu.GibFaktorNamen(faktorTyp)
        dialog=AuswahlDialog(self,'Faktor(en) wählen',faktorNamen)
        return dialog.result # bei cancel None
        
    def TermAuswahlDialog(self, faktorName):
        faktor=Faktor.FaktorZuNamen(faktorName)
        if not (faktor.__class__ in (Fluss,Parameter,Zwischengroesse)): return None
        auswahlen=['t', 'wenn', 'wurzel','quadrat','potenz','sin','cos','exp','min','max']
        if faktor.__class__ in (Fluss,Zwischengroesse):
            auswahlen=faktor.ZeigeFaktorNamen()+auswahlen
        dialog=AuswahlDialog(self,u'Faktor oder Funktion wählen',auswahlen,True)
        return dialog.result # bei cancel None
        
    def Meldung(self, text, titel='Info'):
        MeldungDialog(self, titel, text)

    def ZeigeHilfeText1(self):
        TextAusgabeDialog(
            self,
            u'Hilfe zu Faktoren (Größen)',
            u'Faktoren (Größen)',
            [self.simu.ZeigeHilfe(1)])
    def ZeigeHilfeText2(self):
        TextAusgabeDialog(
            self,
            u'Hilfe zur Modelldefinitionsdatei',
            u'Modelldefinition',
            ["\nMuster für die Modelldefinition mit Grafik:",
             "  Dateiname: '<Modellname>.simdat'\n",
             "Inhalte sind Listen von Tupeln:",
             " ('Bestand',<Name>, <Anfangswert>,(<xPos>,<yPos>))",
             " ('Bestand',<Name>)",
             " ('Fluss',<Name>, <aus_Bestand>, <in_Bestand>)",
             " ('Parameter',<Name>, <Wert>,(<xPos>,<yPos>))",
             " ('Zwischengroesse', <Name>,(<xPos>,<yPos>))",
             " ('QuelleSenke', <Name>, (<xPos>,<yPos>))",
             " ('Wirkung',<von_Faktor>, <auf_Faktor>,<Bogenorientierung>)",
             " ('Term',<Faktor_Name,<Term>)",
             "   Faktornamen im Term immer mit () beenden(!),",
             " damit das Auswerten ausgelöst wird.",
             "   Verzoegerung in der Klammer eingeben,",
             "beispielsweise: Fische(3) ."]
                 )
        
    def ZeigeHilfeText3(self):
        TextAusgabeDialog(
            self,
            u'Hilfe zu Kurztasten',
            u'Kurztasten',
            [u'Strg-o     Datei öffnen',
             u'Strg-s     Datei speichern',
             u'Strg-d     Modelldaten zeigen',
             u'Strg-p     Bild speichern',
             u'Alt-n      Neues Modell',
             u'Alt-b      Neuer Bestand',
             u'Alt-f      Neuer Fluss',
             u'Alt-p      Neuer Parameter',
             u'Alt-z      Neue Zwischengröße',
             u'Alt-w      Neue Wirkung',
             u'Alt-m      Neue Wirkung mit Maus'])

    def ZeigeHilfeText4(self):
        TextAusgabeDialog(
            self,
            u'Hilfe zu Mausaktionen',
            u'Mausaktion',
            [u'linke Maustaste',
             u'  Ziehen von Größen (Faktoren)\n',
             u'rechte Maustaste, alternativ  Control-linke-Maustaste',
             u'  Kontext bei Größen und Wechsel der Bogenorientierung bei Wirkungen\n',
             u'Doppelklick links',
             u'  Terme von Größen (Faktoren)'])

    def ZeigeHilfeText5(self):
        TextAusgabeDialog(
            self,
            u'Hilfe zu Modellfenstervarianten',
            u'Varianten der Modellfenstergröße und Hintergrundfarbe',
            ['Sichern und Beenden Sie gegebenenfalls das Projekt.',
             'Starten Sie es dann neu mit der gewünschten Projektdatei,',
             '- der Datei "SimulationApp.py" mit fester Größe, aber Scrollbalken,',
             '- der Datei "SimulationApp_Groesse_setzen.py",',
             '- der Datei "SimulationApp_Groesse_variabel.py" oder',
             'für Fenster mit schwarzem Hintergrund mit',
             '- der Datei "SimulationApp_Hintergrund_schwarz.py"',
             'ACHTUNG: Bild speichern nur bei weißen Hintergrund!!!'])

    def ZeigeHilfeText6(self):
        TextAusgabeDialog(
            self,
            u'Hilfe zur Bilddateien',
            u'Bilddatei',
            ['ACHTUNG: Bild speichern nur bei weißen Hintergrund!!!\n',
             'Es sind postscript-Dateien [.ps], ein Vektorgrafik-Format.\n',
             'Die Dateien können mit anderer Vektorgrafik-Software konvertiert werden;',
             'z.B. Inkscape, irfanview mit addons und vorhandenem GhostScript.\n',
             'Bei Apple-Systemen öffnen Sie die Datei in der „Vorschau“',
             'und exportieren das Bild dann ins gewünschte Bildformat.'])
        
    #### Beispiele zeichnen
    def zeichne_Objekte(self):
        if len(Faktor.GibAlleFaktorNamen())>1: # mehr als t
            MeldungDialog(self,'Achtung !','Fenster ist nicht leer!\nFuer Beispiel Programm neu starten!')
            return
        zf = self.zeichenflaeche

        self.__modellVariable.set('Beispielmodell')
        name='x'
        self.simu.NeuerBestandsfaktor(name, 3.0)
        be=BestandsElement(zf, name, pos=(200,300))
        
        name='a'
        zg=self.simu.NeueZwischengroesse(name)
        zg.SetzeTerm('x()')
        zge=ZwischengroesseElement(zf, name, pos=(120,150))

        self.simu.NeueWirkung('x', 'a')
        wi=WirkungElement(zf, 'x', 'a')

        name='v'
        fl=self.simu.NeuerFluss(name, 'Quelle', 'x')
        fl.SetzeTerm('a()')
        fe=FlussElement(zf, name, 'Quelle', 'x')
        
        self.simu.NeueWirkung('a', 'v')
        wi2=WirkungElement(zf, 'a', 'v')

## Alternative        
##        self.simu=Simulation.GibSimulation()
##        name='Gesunde'
##        self.simu.NeuerBestandsfaktor(name, 100.0)
##        be1=BestandsElement(zf, name, pos=(50,300))
##        
##        name='Kranke'
##        self.simu.NeuerBestandsfaktor(name, 1.0)
##        be2=BestandsElement(zf, name, pos=(300,350))
##
##        name='erkranken'
##        self.simu.NeuerFluss(name, 'Gesunde', 'Kranke')
##        fl=FlussElement(zf, name, 'Gesunde', 'Kranke')
        
#### ----------------------------------------------------------------------


#### als Hauptfenster starten
if __name__=='__main__':
    root = Tk()
    modell_Fenster = ModellFensterApplication(master=root)
    modell_Fenster.master.title('Entwicklung Simulation')
    grafik_Fenster=GrafikFenster(modell_Fenster)
    ##root.wait_window(grafikfenster)
    modell_Fenster.mainloop()
    try:
        grafik_Fenster.destroy()
        root.destroy()
    except Exception: pass
